/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest{}

// AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest struct for AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest
type AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest struct {
	OAuthId *int32 `json:"oAuthId,omitempty"`
}

// NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest instantiates a new AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest() *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest {
	this := AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest{}
	return &this
}

// NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequestWithDefaults instantiates a new AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequestWithDefaults() *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest {
	this := AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) SetOAuthId(v int32) {
	o.OAuthId = &v
}

func (o AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	return toSerialize, nil
}

type NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest struct {
	value *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest
	isSet bool
}

func (v NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) Get() *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest {
	return v.value
}

func (v *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) Set(val *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest(val *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest {
	return &NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest{value: val, isSet: true}
}

func (v NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
